local BestInSlot = LibStub("AceAddon-3.0"):NewAddon("BestInSlot", "AceComm-3.0", "AceHook-3.0", "AceSerializer-3.0", "AceTimer-3.0")
local AceGUI = LibStub("AceGUI-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("BestInSlot")
local BabbleInventory = LibStub("LibBabble-Inventory-3.0"):GetLookupTable()
local AceEvent = LibStub("AceEvent-3.0")
BestInSlot.options = {}
BestInSlot.options.DEBUG = false
--@non-debug@ 
BestInSlot.version = 102 
--@end-non-debug@


-------------------------------------------------
-- Local copies of global values
-- 
local tinsert, tsort, tconcat, tremove = table.insert, table.sort, table.concat, table.remove
local GetNumSpecializations, GetSpecializationInfo, GetItemInfo, IsEquippedItem, GetContainerNumSlots, GetContainerItemID, UnitClass, GetItemStats, GetInventorySlotInfo, GetNumGuildMembers = GetNumSpecializations, GetSpecializationInfo, GetItemInfo, IsEquippedItem, GetContainerNumSlots, GetContainerItemID, UnitClass, GetItemStats, GetInventorySlotInfo, GetNumGuildMembers
local slashCommands = {}
local defaults = {
  char = {
    ['**'] = { --Specialization
      ['**'] = { --raidTiers
         ['**'] = { --Raid difficulty
          ['**'] = { --Slots
          
          }
         }
       },
    },
    latestVersion = 1,
    options = {
      windowFixed = false,
      instantAnimation = true,
      showBiSTooltip = true,
      sendAutomaticUpdates = true,
      receiveAutomaticUpdates = true,
      minimapButton = true
    }
  },
  global = {
    options = {
    
    },
    customItems = {
      ['**'] = { --itemId
        raidTier = nil,
        difficulty = nil,
        type = nil,
        dungeon = nil,
        boss = nil,
      }
    }
  },
  factionrealm = {
    ['**'] = { --guildname
      ['**'] = { -- charactername
        ['**'] = { -- raidTier
          ['**'] = { -- difficulty
          
          }
        }
      }
    }
  },
  profile = {
    minimap = {
      hide = false,
    }
  }
}

---
--Datatypes to be used with some of BestInSlots functions
---
BestInSlot.TYPE_EXPANSION = 1
BestInSlot.TYPE_RAIDTIER = 2
BestInSlot.TYPE_INSTANCE = 3
BestInSlot.TYPE_BOSS = 4
BestInSlot.TYPE_DIFFICULTY = 5

BestInSlot.MSGPREFIX = "BiS"
---
--Color codes used by the add-on
---
BestInSlot.colorHighlight = "|cffff0000"
BestInSlot.colorNormal = "|cffffd100"
---
--data = {
--  raidTiers = {
--    [raidTierId] = {
--      description = "Raid Tier Description",
--      difficulties = {"difficultyName1", "difficultyName2"},
--      expansion = expansionId, 
--      instances = {},
--      tierItems = {
--        [Class1] = {
--          [difficultyName1] = {
--            tierItemId1,
--            tierItemId2,
--            tierItemId3,
--          },
--          [difficultyName2] = {
--            tierItemId1,
--            tierItemId2,
--            tierItemId3,
--          },
--        }
--      } 
--    }
--  },
--  instances = {
--    [instanceId] = {
--      raidTier = raidTierID,
--      expansion = expansionId,
--      description = "Description
--    }    
--  },
--  expansions = {
--    [expansionId] = {
--      raidTiers = {},
--      instances = {},
--      description = "Description",
--    }
--  }
--}
---
local data = {
  raidTiers = {},
  instances = {},
  expansions = {},
}
---
--moduleData = {
--  [ExpansionLocalized] = {
--    description = "Expansion" 
--    [DungeonLocalized] = {
--      description = "DungeonDescription"
--      raidTier = raidTierId   <-- The raidtier defines a couple of stuff, along with underneath comment
--      [BossId] = {
--        [difficultyName1] = { <-- The difficulties as defined in BestInSlot.raidTiers[raidTier].difficulties must be present in the dungeon!
--          itemid1,
--          itemid2,
--          itemid3,
--        }
--        [difficultyNameN] ={
--          itemid1,
--          itemid2,
--          itemid3,
--        }
--        
--        [info] = {
--          name = BossName
--          
--        }
--      }
--    }
--  }
--}
---
local moduleData = {}
---
--itemData = {
--  [itemId1] = {
--    raidId = raidId
--    expansionId = expansionId
--    raidTier = raidTier
--    link = itemlink as returned by GetItemInfo(itemid)
--    class = itemclass as returned by GetItemInfo(itemid)
--    subclass = itemsubclass as returned by GetItemInfo(itemid)
--    equipSlot = equipment slot of the item
--    source = String representation of the source of the item : "Garrosh Hellscream"
--    bossid = if it drops from a boss, this field contains the id of the boss where it drops
--    classRestriction = class for whom this item is
--    difficultyId = Id of the difficulty this item belongs to, nil if none
--    difficultyName = Name of the difficulty this item belongs to, nil if none
--    quality = ItemQuality as returned by GetItemInfo(itemid)
--  }
--  [itemId2] = {
--    raidId = raidId
--    etcetera
--  }
--}
---
local itemData = {}
BestInSlot.slots = {"HeadSlot", "NeckSlot","ShoulderSlot","BackSlot","ChestSlot","WristSlot","HandsSlot","WaistSlot","LegsSlot","FeetSlot", "Finger0Slot","Finger1Slot","Trinket0Slot","Trinket1Slot", "MainHandSlot","SecondaryHandSlot"}
BestInSlot.invSlots = {
  [1] = "INVTYPE_HEAD",
  [2] = "INVTYPE_NECK",
  [3] = "INVTYPE_SHOULDER",
  [4] = "INVTYPE_BODY",
  [5] = {"INVTYPE_CHEST", "INVTYPE_ROBE"},
  [6] = "INVTYPE_WAIST",
  [7] = "INVTYPE_LEGS",
  [8] = "INVTYPE_FEET",
  [9] = "INVTYPE_WRIST",
  [10] = "INVTYPE_HAND",
  [11] = "INVTYPE_FINGER",
  [12] = "INVTYPE_FINGER",
  [13] = "INVTYPE_TRINKET",
  [14] = "INVTYPE_TRINKET",
  [15] = "INVTYPE_CLOAK",
  [16] = {"INVTYPE_WEAPON", "INVTYPE_2HWEAPON", "INVTYPE_WEAPONMAINHAND", "INVTYPE_RANGED", "INVTYPE_RANGEDRIGHT"},
  [17] = {"INVTYPE_WEAPONOFFHAND", "INVTYPE_SHIELD", "INVTYPE_WEAPON", "INVTYPE_HOLDABLE"},
  --[18] = {"INVTYPE_RANGED", "INVTYPE_THROWN", "INVTYPE_RANGEDRIGHT", "INVTYPE_RELIC"} 
}
BestInSlot.itemFilter = {
    [BabbleInventory["Armor"]] = {
      [BabbleInventory["Cloth"]] = {"MAGE", "WARLOCK", "PRIEST"},
      [BabbleInventory["Leather"]] = {"DRUID", "MONK", "ROGUE"},
      [BabbleInventory["Mail"]] = {"SHAMAN", "HUNTER"},
      [BabbleInventory["Plate"]] = {"PALADIN", "DEATHKNIGHT", "WARRIOR"},
      [BabbleInventory["Shields"]] = {"PALADIN", "SHAMAN", "WARRIOR"},
    },
    [BabbleInventory["Weapon"]] = {
      [BabbleInventory["Bows"]] = {"HUNTER"},
      [BabbleInventory["Crossbows"]] = {"HUNTER"},
      [BabbleInventory["Daggers"]] = {"DRUID", "MAGE", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK"},
      [BabbleInventory["Fist Weapons"]] = {"MONK", "ROGUE", "SHAMAN"},
      [BabbleInventory["Guns"]] = {"HUNTER"},
      [BabbleInventory["One-Handed Axes"]] = {"DEATHKNIGHT", "MONK", "PALADIN", "ROGUE", "SHAMAN", "WARRIOR"},
      [BabbleInventory["One-Handed Maces"]] = {"DEATHKNIGHT", "DRUID", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARRIOR"},
      [BabbleInventory["One-Handed Swords"]] = {"DEATHKNIGHT", "MAGE", "MONK", "PALADIN", "ROGUE", "WARLOCK", "WARRIOR"},
      [BabbleInventory["Polearms"]] = {"DEATHKNIGHT", "MONK", "PALADIN", "WARRIOR"},
      [BabbleInventory["Staves"]] = {"DRUID", "MAGE", "MONK", "PRIEST", "SHAMAN", "WARLOCK"},
      [BabbleInventory["Two-Handed Axes"]] = {"DEATHKNIGHT", "PALADIN", "WARRIOR"},
      [BabbleInventory["Two-Handed Maces"]] = {"DEATHKNIGHT", "DRUID", "PALADIN", "WARRIOR"},
      [BabbleInventory["Two-Handed Swords"]] = {"DEATHKNIGHT", "PALADIN", "WARRIOR"},
      [BabbleInventory["Wands"]] = {"MAGE", "PRIEST", "WARLOCK"},
    },
    ["DualWield"] = {"MONK", "ROGUE", "SHAMAN", "DEATHKNIGHT", "WARRIOR"},
    ---
    --All stats:
    -- Stamina      - "ITEM_MOD_STAMINA_SHORT"
    -- Strength     - "ITEM_MOD_STRENGTH_SHORT"
    -- Agility      - "ITEM_MOD_AGILITY_SHORT"
    -- Intellect    - "ITEM_MOD_INTELLECT_SHORT"
    -- 
    -- Mastery      - "ITEM_MOD_MASTERY_RATING_SHORT"
    -- Haste        - "ITEM_MOD_HASTE_RATING_SHORT"
    -- Hit          - "ITEM_MOD_HIT_RATING_SHORT"
    -- Crit         - "ITEM_MOD_CRIT_RATING_SHORT"
    -- Spirit       - "ITEM_MOD_SPIRIT_SHORT"
    -- Expertise    - "ITEM_MOD_EXPERITSE_RATING_SHORT"
    -- Dodge        - "ITEM_MOD_DODGE_RATING_SHORT"
    -- Parry        - "ITEM_MOD_PARRY_RATING_SHORT"
    -- 
    -- Armor        - "RESISTANCE0_NAME"
    -- 
    -- Meta Socket  - "EMPTY_SOCKET_META"
    -- Blue Socket  - "EMPTY_SOCKET_BLUE"
    -- Red Socket   - "EMPTY_SOCKET_RED"
    -- 
    -- Yellow Socket- "EMPTY_SOCKET_YELLOW"
    ["StatFilter"] = { --contains stats that are NOT used by this class at all
      ["DEATHKNIGHT"] = {"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"},
      ["DRUID"] = {"ITEM_MOD_STRENGTH_SHORT"},
      ["HUNTER"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["MAGE"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["MONK"] = {"ITEM_MOD_STRENGTH_SHORT"},
      ["PALADIN"] = {"ITEM_MOD_AGILITY_SHORT"},
      ["PRIEST"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["ROGUE"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["SHAMAN"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["WARLOCK"] = {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"},
      ["WARRIOR"] = {"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"},
      [250] = {}, --Blood Death Knight
      [251] = {"ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Frost Death Knight 
      [252] = {"ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Unholy Death Knight
      [102] = {"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Balance Druid
      [103] = {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Feral Druid
      [104] = {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"}, --Guardian Druid
      [105] = {"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Restoration Druid
      [253] = {}, --Beast Mastery Hunter
      [254] = {}, --Marksmanship Hunter
      [255] = {}, --Survival Hunter
      [62] =  {}, --Arcane Mage
      [63] =  {}, --Fire Mage
      [64] =  {}, --Frost Mage
      [268] = {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"}, --Brewmaster Monk
      [269] = {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Windwalker Monk
      [270] = {"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Mistweaver Monk
      [65] =  {"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Holy paladin
      [66] =  {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"}, --Protection Paladin
      [70] =  {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT", "ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Retribution Paladin
      [256] = {}, --Discipline Priest
      [257] = {}, --Holy Priest
      [258] = {}, --Shadow Priest
      [259] = {}, --Assassination Rogue
      [260] = {}, --Combat Rogue
      [261] = {}, --Subtlety Rogue
      [262] = {"ITEM_MOD_AGILITY_SHORT"}, --Elemental Shaman
      [263] = {"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_SPIRIT_SHORT"}, --Enhancement Shaman
      [264] = {"ITEM_MOD_AGILITY_SHORT"}, --Restoration Shaman
      [265] = {}, --Affliction Warlock
      [266] = {}, --Demonology Warlock
      [267] = {}, --Destruction Warlock
      [71] =  {"ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Arms Warrior
      [72] =  {"ITEM_MOD_DODGE_RATING_SHORT", "ITEM_MOD_PARRY_RATING_SHORT"}, --Fury Warrior
      [73] =  {}, --Protection Warrior 
        
      
    }
}

------------------------------------------------------------------------------------------------------------------------------------------------
-- MODULE REGISTRATION 
------------------------------------------------------------------------------------------------------------------------------------------------

--- This function can be used by modules to add their data to the add-on. It checks if the proper values are set
--@param #string unlocalizedName the Localized Name of the expansion to register
--@param #string localizedDescription The localized description of the expansion to add
function BestInSlot:RegisterExpansion(unlocalizedName, localizedDescription)
  if moduleData[unlocalizedName] or data.expansions[unlocalizedName]  then
    error("The expansion "..localizedDescription.." is allready registered!")
  end
  moduleData[unlocalizedName] = {}
  data.expansions[unlocalizedName] = {description = localizedDescription, raidTiers = {}, instances = {}}
end
--- Registers a raid tier to BestInSlot
-- @param #string expansion The expansion ID, must have been registered before by using BestInSlot:RegisterExpansion
-- @param #number raidTier The number corresponding with the Raid Tier, must be unique. The standard is to use the patch version the raid tier belongs to (e.g. 50400 for patch 5.4)
-- @param #string description The description of the raid tier. By default 'Patch 5.4'
-- @param #... The next parameters are considered the difficulties you would like to add, can be "Normal", "Heroic", and "Mythic".
function BestInSlot:RegisterRaidTier(expansion, raidTier, description, ...)
  local difficulties = {...}
  if data.raidTiers[raidTier] then error("This raid tier is allready registered!") end
  if not data.expansions[expansion] then error("The expansion has not been registered yet!") end
  if not description or type(description) ~= "string" then error("The raid tier needs to provide a description!") end
  if not difficulties or #difficulties == 0  then error("The raid tier "..description.." needs to provide difficulties!") end
  for i = 1,#difficulties do
    if type(difficulties[i]) ~= "string" then error("Difficulty parameter not set correctly") end
  end
  data.raidTiers[raidTier] = {description = description, difficulties = difficulties}
  data.raidTiers[raidTier].expansion = expansion
  data.raidTiers[raidTier].instances = {}
  tinsert(data.expansions[expansion].raidTiers, raidTier)
end

---Register a raid instance to BestInSlot
--@param #number raidTier The raidTier ID as used at BestInSlot:RegisterRaidTier
--@param #string unlocalizedName An unlocalized name of the raid to add, to identify the instance, must be unique!
--@param #string description A localized description of the raid instance to add
function BestInSlot:RegisterRaidInstance(raidTier, unlocalizedName, description)
  if not data.raidTiers[raidTier] then error("The raid tier "..raidTier.." has not been registered yet!") end
  local localizedExpansion = data.raidTiers[raidTier].expansion
  if not moduleData[localizedExpansion] or not data.expansions[localizedExpansion] then error("The expansion "..localizedExpansion.." has not been registered yet!") end
  if not data.raidTiers[raidTier] then error("The raid tier "..raidTier.." has not been registered yet") end
  if data.instances[unlocalizedName] then error("This raid instance has allready been registered!") end
  if moduleData[localizedExpansion][unlocalizedName] then error("The loot source "..description.." has allready been registered!") end
  moduleData[localizedExpansion][unlocalizedName] = {description = description, raidTier = raidTier}
  data.instances[unlocalizedName] = {expansion = localizedExpansion, raidTier = raidTier, description = description}
  tinsert(data.expansions[localizedExpansion].instances, unlocalizedName)
  tinsert(data.raidTiers[raidTier].instances, unlocalizedName)
end

---Register tier items that drop in the supplied raidTier
--@param #number raidTier The raid tier that drops the tier items
--@param #table tierItems A table in the following format: {DEATHKNIGHT = { NORMAL = { normalItem1, normalItem2, ...}, HEROIC = { heroicItem1, heroicItem2},} SHAMAN = {....}} Where the difficulties must correspond with the earlier registered difficulties
function BestInSlot:RegisterTierItems(raidTier, tierItems)
  if not data.raidTiers[raidTier] then error("This raid tier is not registered yet") end
  local raidTierData = data.raidTiers[raidTier]
  local difficulties = raidTierData.difficulties
  local classes = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR"}
  for i=1,#classes do
    if not tierItems[classes[i]] then error("The tierItems list is missing the class: "..classes[i]) end
    for j=1,#difficulties do
      if not tierItems[classes[i]][difficulties[j]] then error("The tier list is missing the difficulty "..difficulties[j].." at class "..classes[i]) end
    end
  end
  raidTierData.tierItems = tierItems
end
--- Register Miscelaneous items
-- @param #number raidTier The Raid tier to add the misc items to
-- @param #table miscItems A table containing the miscelaneous items, should be formatted in the following format: {["Legendary Cloak Quest"] = {idCloak1, idCloak2, ...}, ["Ordos"] = {idOrdos1, idOrdos2, ...}}
function BestInSlot:RegisterMiscItems(raidTier, miscItems)
  if not data.raidTiers[raidTier] then error("This raid tier is not registered yet") end
  local raidTier = data.raidTiers[raidTier]
  for k,v in pairs(miscItems) do
    if type(k) ~= "string" or type(v) ~= "table" then error("Misc table is not formatted properly, should be {key = {itemId1, itemId2}} Where key is a description of the source}") end
  end
  raidTier.misc = miscItems
end

--- Register boss loot of an instance. Must call this function in the order you want to put the bosses in
-- @param #string unlocalizedInstanceName The unlocalized name of the instance to add the loot to.
-- @param #table lootTable The table containing the loot for the boss, must be formatted as follows: {["Normal"] = {itemId1, itemId2}, ["Heroic"] = {itemId1, itemId2}}
-- @param #string bossName Localized name of the boss, you can use LibBabbleBoss-3.0 for this.
-- @param #number tierToken If supplied, registers this item as a boss that drops the supplied tiertoken. 10 = Handslot, 5 = ChestSlot, 1 = HeadSlot, 3 = ShoulderSlot, 7 = LegsSlot
function BestInSlot:RegisterBossLoot(unlocalizedInstanceName, lootTable, bossName, tierToken)
  local instance = data.instances[unlocalizedInstanceName]
  local moduleData = moduleData[instance.expansion][unlocalizedInstanceName]
  if not instance then error("The instance \""..unlocalizedInstanceName.."\" has not yet been registered!") end
  local raidTier = instance.raidTier
  local difficulties = data.raidTiers[raidTier].difficulties
  for i=1,#difficulties do
    if not lootTable[difficulties[i]] then
      error("Loottable for boss: "..bossName.." doesn't have a loottable for "..difficulties[i])
    end
  end
  if tierToken then
    lootTable.info = {name = bossName, tierToken = tierToken}
  else
    lootTable.info = {name = bossName}
  end
  tinsert(moduleData, lootTable)
  self.hasModules = true
end

--Simple helper to check if an array has any key
local function hasItems(array)
  for _ in pairs(array) do
    return true
  end
  return false
end

--- Verify database structure when a change in database is done
function BestInSlot:VerifyDatabaseStructure()
  local charDb = self.db.char
  if charDb.latestVersion <= 96 then
    local raidTiers = self:GetRaidTiers()
    for _, raidTier in pairs(raidTiers) do
      if hasItems(charDb[raidTier]) then
        for difficultyId, difficulty in pairs(self:GetDifficulties(self.TYPE_RAIDTIER, raidTier)) do
          if hasItems(charDb[raidTier][difficultyId]) then
            local tempBackup = charDb[raidTier][difficultyId]
            local doneBefore = false
            local numSpecializations = GetNumSpecializations()
            for i=1, numSpecializations do
              local id = GetSpecializationInfo(i)
              if hasItems(tempBackup[id]) then
                doneBefore = true
                break
              end
            end
            if not doneBefore then
              local newArray = {}
              for i=1, numSpecializations do
                local newItemList = {}
                local id = GetSpecializationInfo(i)
                for k,v in pairs(tempBackup) do
                  if type(v) == "number" then
                    newItemList[k] = v
                  end
                end
                newArray[id] = newItemList
              end
              charDb[raidTier][difficultyId] = newArray
            end
          end
        end
      end
    end
  end
  charDb.latestVersion = self.version
end

--- Called on initializing the add-on
function BestInSlot:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("BestInSlotDB", defaults)
  SLASH_BESTINSLOT1, SLASH_BESTINSLOT2 = '/bestinslot', '/bis'
  self:RegisterComm(self.MSGPREFIX)
  self.options.instantAnimation = self.db.global.options.instantAnimation
  self.options.showBiSTooltip = self.db.char.options.showBiSTooltip
  self.options.windowFixed = self.db.char.options.windowFixed
  self.options.sendAutomaticUpdates = self.db.char.options.sendAutomaticUpdates
  self.options.receiveAutomaticUpdates = self.db.char.options.receiveAutomaticUpdates
  
  self:RegisterMinimapIcon()
  
  self:Print((L["has been initialized, use %s to show the GUI"]):format((L["%s or %s"]):format(self.colorHighlight.."/bis"..self.colorNormal, self.colorHighlight.."/bestinslot"..self.colorNormal)))
end

--- Called on enabling the add-on
function BestInSlot:OnEnable()
  self:HookScript(GameTooltip, "OnTooltipSetItem", "GameTooltip_OnTooltipSetItem")
  self:VerifyDatabaseStructure()
  AceEvent:RegisterEvent("PLAYER_GUILD_UPDATE", function()
    BestInSlot:SendEvent("PLAYER_GUILD_UPDATE")
  end)
end

function BestInSlot:OnDisable()
  self:Unhook("OnTooltipSetItem")
end
---[[DEPRECATE--
local BestInSlotScanTooltip = CreateFrame("GAMETOOLTIP", "BestInSlotScanTooltip", nil, "GameTooltipTemplate")
BestInSlotScanTooltip:SetOwner(UIParent, "ANCHOR_NONE")
--- Returns the difficulty based on the tooltip
-- @param #number itemid The itemid
-- @return #string A string representation of the difficulty, defaults to Normal
local function GetItemDifficulty(itemid)
  BestInSlotScanTooltip:SetOwner(UIParent, "ANCHOR_NONE")
  BestInSlotScanTooltip:ClearLines()
  BestInSlotScanTooltip:SetHyperlink("item:"..itemid)
  BestInSlotScanTooltip:Show()
  local difficulty = BestInSlotScanTooltipTextLeft2:GetText()
  BestInSlotScanTooltip:Hide()
  if difficulty and (difficulty):find(PLAYER_DIFFICULTY2) then
    return PLAYER_DIFFICULTY2
  elseif difficulty and (difficulty):find("Mythic") then
    --TODO Warlords Of Draenor: See what the global is for the mythic difficulty
    return "Mythic"
  else
    return PLAYER_DIFFICULTY1
  end
end

--- Checks wether the player has the supplied item equipped, it should consider normal and warforged items the same
-- @param #number itemid The item ID to check if it's equipped
-- @return #boolean True if item equipped, otherwise false
function BestInSlot:HasItemEquipped(itemid)
  local item = self:GetItem(itemid)
  local name
  if item then
    name = item.name
  else
    name = GetItemInfo(itemid)
  end
  if IsEquippedItem(itemid) then
    return true
  end
  return false
end

--- Checks if the player has an item in their bags, or an item similar to it (warforged version for example)
-- @param #number itemid The itemID to check if the player has it in their bags
-- @return #boolean true if the player has the item in their bag, otherwise false
function BestInSlot:HasItemInBag(itemid)
  local bags = NUM_BAG_SLOTS
  local name = GetItemInfo(itemid)
  for i=0,bags do
    local bagSize = GetContainerNumSlots(i)
    for j=1,bagSize do
      local id = GetContainerItemID(i, j)
      if id == itemid then
        return true
      end
    end
  end
  return false
end

--- Checks if the player has an item either in their bags, or equipped
-- @param #number itemid The itemID to check if the player has
-- @return #boolean true if the player has it, otherwise false
function BestInSlot:HasItem(itemid)
  return self:HasItemEquipped(itemid) or self:HasItemInBag(itemid)
end

------------------------------------------------------------------------------------------------------------------------------------------------
-- Slash Commands
------------------------------------------------------------------------------------------------------------------------------------------------

--- A BestInSlot function to register a custom slash command. This will automatically be displayed at /help and should be able to be called through /bis [cmd]
-- @param #string cmd The command to register
-- @param #string descr The description to be displayed when '/bis help' is being typed
-- @param #function func The function to be called when this slash command is invoked
-- @param #number prefOrder The preferred location of this message in the '/bis help' dialog. Can be nil
function BestInSlot:RegisterSlashCmd(cmd, descr, func, prefOrder)
  if type(cmd) ~= "string" then error("Command should be a string") end
  if type(func) ~= "function" then error("Second argument of RegisterSlashCmd should be the function that should be called when the command is given") end
  if type(descr) ~= "string"  then error("Slashcommand should provide a description as third parameter") end
  if prefOrder and type(prefOrder) ~= "number" then error("If provided, prefOrder should be a number") end
  cmd = (cmd):lower()
  if slashCommands[cmd] then error("Slash command "..cmd.." is allready registered!") end
  slashCommands[cmd] = {func = func, descr = descr, prefOrder = prefOrder}
end
                  
function SlashCmdList.BESTINSLOT(msg, editbox)
  local args = {}
  local first = true
  local command
  for w in (msg):gmatch("%w+") do
    if first then
      command = w
      first = false
    else
      tinsert(args, w)
    end
  end
  if not command then
    slashCommands.show.func()
  else
    command = (command):lower()
    if not slashCommands[command] then
      BestInSlot:Print((L["Command not recognized, try '%s' for help"]):format("/bis help"), true)
    else
      slashCommands[command].func(unpack(args))
    end
  end
end

BestInSlot:RegisterSlashCmd("help", (L["%s - this dialog"]):format("/bis help"), function()
  local orderedList = {}
  for k in pairs(slashCommands) do
    tinsert(orderedList, k)
  end
  tsort(orderedList)
  for i=1,#orderedList do
    if slashCommands[orderedList[i]].prefOrder then
      tinsert(orderedList, slashCommands[orderedList[i]].prefOrder, orderedList[i])
      tremove(orderedList, i + 1)
    end
  end
  print(BestInSlot.colorHighlight..("-"):rep(5)..BestInSlot.colorNormal.."BestInSlot "..L["commands"]..BestInSlot.colorHighlight..("-"):rep(5).."|r")
  BestInSlot:Print(("%s: %s (%s)"):format(GAME_VERSION_LABEL, GetAddOnMetadata("BestInSlot", "Version"), BestInSlot.version))
  for i=1,#orderedList do
    BestInSlot:Print(slashCommands[orderedList[i]].descr, true)
  end
  print(BestInSlot.colorHighlight..("-"):rep(36).."|r")
end)

BestInSlot:RegisterSlashCmd("debug", (L["%s - enable/disable debug messages"]):format("/bis debug"), function()
  if BestInSlot.options.DEBUG then
    BestInSlot:Print(L["Disabling debug messages"])
    BestInSlot.options.DEBUG = false
  else
    BestInSlot.options.DEBUG = true
    BestInSlot:Print(L["Enabling debug messages"])
  end
  BestInSlot:SendEvent("DebugOptionsChanged", BestInSlot.options.DEBUG) 
end)
------------------------------------------------------------------------------------------------------------------------------------------------
-- Loot Table initialization
------------------------------------------------------------------------------------------------------------------------------------------------

--- Helper to set the item info obtained from WoW's API
local function SetItemInfoData(item, itemId, getTierSource)
  local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemId)
  if name then
    item.name = name
    item.link = link
    item.class = class
    item.subclass = subclass
    item.equipSlot = equipSlot
    item.quality = quality
    item.isBiS = BestInSlot:IsItemBestInSlot(itemId)
    if item.getSourceInfo and getTierSource then
      local sourceInfo = getTierSource(equipSlot)
      item.raidId = sourceInfo.raidId
      item.source = sourceInfo.source
      item.bossid = sourceInfo.bossid
      item.getSourceInfo = nil
    end
    return true
  end
  return false
end

--- Initialize a lootTable
-- @param #number raidTier The ID of the raidTier to initialize
function BestInSlot:InitializeLootTable(raidTier)
  if not data.raidTiers[raidTier] then return end
  --Has the raid tier been initialized earlier?
  if data.raidTiers[raidTier].isInitialized then return end
  --array for saving items that aren't retrieved
  local items = {}
  local counter = 0
  local raidTierInfo = data.raidTiers[raidTier]
  if not raidTierInfo then return false end
  local raids = self:GetInstances(self.TYPE_RAIDTIER, raidTier)
  local expansion = self:GetExpansions(self.TYPE_RAIDTIER, raidTier)
  if #raids == 0 then return false end
  local tierSources = {} 
  
  --Initialize the bosses by bossid
  local itemTable = {}
  for i=1,#raids do
    local bosses = moduleData[expansion][raids[i]]
    for bossId=1,#bosses do
      --make the tierSources array for use later on
      if bosses[bossId].info.tierToken then
        tierSources[bosses[bossId].info.tierToken] = {
          bossid = bossId,
          raidId = raids[i],
          source = bosses[bossId].info.name,
        }
      end
      for difficId=1,#raidTierInfo.difficulties do
        local lootTable = bosses[bossId][raidTierInfo.difficulties[difficId]]
        for item=1, #lootTable do
          local itemInfo = {}
          itemInfo.raidId = raids[i]
          itemInfo.expansionId = expansion
          itemInfo.raidTier = raidTier
          itemInfo.bossid = bossId
          itemInfo.source = bosses[bossId].info.name
          itemInfo.difficultyId = difficId
          SetItemInfoData(itemInfo, lootTable[item])
          itemTable[lootTable[item]] = itemInfo
        end
      end
    end
  end
  
  --Initialize the raid tiers as defined in data.raidTiers[raidTier].tierItems
  local classTiers = data.raidTiers[raidTier].tierItems
  local function getTierSource(equipSlot)
    if tierSources[equipSlot] then return tierSources[equipSlot] end
    local slotId
    for i=1,#self.invSlots do
      if type(self.invSlots[i]) == "string" then
        if self.invSlots[i] == equipSlot then
          slotId = i
          break
        end
      elseif type(self.invSlots[i]) == "table" then
        for j=1,#self.invSlots[i] do
          if self.invSlots[i][j] == equipSlot then
            slotId = i
            break
          end
        end
      end
    end
    if not slotId or not tierSources[slotId] then return end
    tierSources[equipSlot] = tierSources[slotId]
    return tierSources[equipSlot]
  end
  if classTiers ~= nil then
    for className,classData in pairs(classTiers) do
      local difficulties = data.raidTiers[raidTier].difficulties
      for difficId=1,#difficulties do
        local difficultyData = classTiers[className][difficulties[difficId]]
        for i=1,#difficultyData do
          local item = {}
          item.expansionId = expansion
          item.raidTier = raidTier
          item.getSourceInfo = true
          item.classRestriction = className
          item.difficultyId = difficId
          SetItemInfoData(item, difficultyData[i], getTierSource)
          itemTable[difficultyData[i]] = item
        end
      end
    end
  end
  
  --Initialize the miscellaneous items 
  local miscItems = data.raidTiers[raidTier].misc
  if miscItems ~= nil then
    for descr, itemList in pairs(miscItems) do
      for i=1, #itemList do
        local item = {}
        item.raidID = "Misc"
        item.expansionId = expansion
        item.raidTier = raidTier
        item.source = descr
        item.bossid = nil
        SetItemInfoData(item, itemList[i], getTierSource)
        itemTable[itemList[i]] = item
      end
    end
  end
  
  -- Initialize the custom items
  
  local customItems = self.db.global.customItems
  for k,v in pairs(customItems) do
    if v.raidTier == raidTier then
      local item = self:GetCustomItem(k, v.type, v.raidTier, v.difficulty, v.dungeon, v.boss)
      itemTable[k] = item
    end
  end
  
  --Check if we actually got the data from GetItemInfo
  --true: Add it to the item table
  --false: Put it in a table for query'ing later
  
  for i,item in pairs(itemTable) do
    if item.name then
      itemData[i] = item
    else
      counter = counter + 1
      items[i] = item
    end
  end
  
  -- Any items that couldn't be found in local cache are put into the items table.
  -- If this table is empty then we're done and we're going to do the function, when provided
  if counter == 0 then
    data.raidTiers[raidTier].isInitialized = true
    self:SendEvent("InitializeLootTable", raidTier)
    return true
  end
  
  -- If the item array still contained items, we're going to wait until this items are cached and then run the function, when provided
  
  self.console:Add("Making wait frame", counter)
  local attempts = 0
  local raidTier = raidTier
  local waitFrame
  waitFrame = BestInSlot:ScheduleRepeatingTimer(function()
    counter = 0
    attempts = attempts + 1
    for i, item in pairs(items) do
      SetItemInfoData(item, i, getTierSource)
    	if item.name then
    	 tinsert(itemData, i, item)
    	 items[i] = nil
    	else
    	 counter = counter + 1
    	end
    end
    if counter == 0 or attempts > 10 then
      if attempts > 10 then
        BestInSlot.console:AddError("Failed to initialize a couple of items:")
        for i, item in pairs(items) do
          BestInSlot.console:AddError("Item "..i, item)
        end
        BestInSlot.console:AddError("End of failed initialize items")
      end
      data.raidTiers[raidTier].isInitialized = true
      BestInSlot:SendEvent("InitializeLootTable", raidTier)
      BestInSlot:CancelTimer(waitFrame)
    end
  end,
  0.1)
  
  -- Return false if currently not initialized
  return false
end
--- Returns wether this raid tier has been initialized or not
-- @param #number raidTier The ID of the raid tier
-- @return #boolean True if raid tier has been initialized, otherwise false
function BestInSlot:IsRaidTierInitialized(raidTier)
  if not raidTier or not data.raidTiers[raidTier] then return false end
  return data.raidTiers[raidTier].isInitialized or false
end

------------------------------------------------------------------------------------------------------------------------------------------------
-- Getters for data
------------------------------------------------------------------------------------------------------------------------------------------------

---
-- This function returns an array of items by id to define in what order it should show the items provided in the itemArray
-- @param #array itemArray The array of items to sort
-- @param #string mode The mode to sort at, currently only supports "SORT_MODE_ILVL" and defaults to that
---
function BestInSlot:GetLootOrder(itemArray, mode)
  local sortArray = {}
  local mode = mode or "SORT_MODE_ILVL"
  if mode == "SORT_MODE_ILVL" then
    for k,v in pairs(itemArray) do
      if #sortArray == 0 then
        tinsert(sortArray, k)
      else
        local position
        for i=1,#sortArray do
          if sortArray[i] > k then
            position = i
            break
          end
        end
        position = position or #sortArray + 1
        tinsert(sortArray, position, k)
      end
    end
  end
  return sortArray
end

--- Retrieve the boss that drops a tier token
-- @param #number raidTier The raidTier to query for the token
-- @param #number slotId The slotID to search the token for
function BestInSlot:GetBossForTierToken(raidTier, slotId)
  local raids = self:GetInstances(self.TYPE_RAIDTIER, raidTier)
  local expansion = self:GetExpansions(self.TYPE_RAIDTIER, raidTier)
  for i=1,#raids do
    local bosses = moduleData[expansion][raids[i]]
    for j=1,#bosses do
      if bosses[j].info.tierToken and bosses[j].info.tierToken == slotId then
        return j, bosses[j].info.name
      end
    end
  end
end

--- Retrieve the loot table that's personalized for the player.
-- @param #number raidTier The raidtier to retrieve the loot table for
-- @param #number slotID The slotID to retrieve the loot table for
-- @param #number difficulty The difficulty ID to retrieve the loot table for
-- @param #number specializationId The specializationID to retrieve the loot for
-- @return #table The loot table for the player
function BestInSlot:GetPersonalizedLootTableBySlot(raidTier, slotId, difficulty, specializationId)
  local items = self:GetLootTableBySlot(raidTier, slotId, difficulty)
  if not items then
    return
  end
  local filter = self.itemFilter
  local _,playerClass = UnitClass("player")
  for id, item in pairs(items) do
    local canUse = true -- in case there isn't a filter
    if item.classRestriction and item.classRestriction ~= playerClass then
      canUse = false
    end
    if canUse and filter[item.class] and filter[item.class][item.subclass] and item.equipSlot ~= "INVTYPE_CLOAK" then --is there a filter for this class and subclass
      local itemFilter = filter[item.class][item.subclass]
      canUse = false
      for j=1,#itemFilter do --check if the class is supposed to use this itemclass + subclass combo
        if itemFilter[j] == playerClass then
          if slotId == 17 and item.class == "Weapon" then --extra check for dual wield weapons
            for k=1,#filter.DualWield do
              if filter.DualWield[k] == playerClass then
                canUse = true
                break
              end
            end
            if canUse then break end
          else
            canUse = true --Item can be used! Break the loop and continue with the next
            break
          end
        end
      end
    end
    if canUse then--item passed filter on armor and weapon proficiency, check if there are stats that the player doesn't use
      local itemStats = GetItemStats(("item:%d"):format(id))
      local statFilter = {} 
      for i=1,#filter.StatFilter[playerClass] do
        tinsert(statFilter, filter.StatFilter[playerClass][i])
      end
      if specializationId then
        for i=1,#filter.StatFilter[specializationId] do
          tinsert(statFilter, filter.StatFilter[specializationId][i])
        end
      end
      for j=1,#statFilter do
        if itemStats[statFilter[j]] then --if the provided stat is defined as not used by this class
          canUse = false
          break
        end
      end
    end
    if not canUse then
      items[id] = nil
    end
  end
  return items
end

--- Get the loottable for the supplied raidTier, slot, and difficulty
-- @param #number raidTier The raidtier to request the loot table off
-- @param #number slotId The Slot ID to request
-- @param #number difficulty The difficulty ID of the raidTier to request the data off
-- @return #table The loot table
function BestInSlot:GetLootTableBySlot(raidTier, slotId, difficulty)
  if not data.raidTiers[raidTier].isInitialized then
    if not self:InitializeLootTable(raidTier) then return end
  end
  
  local items = {}
  for id, item in pairs(itemData) do
    local addItem = true --Boolean used to define if the item will be added to the loottable
    if item.raidTier ~= raidTier then
      addItem = false
    end
    if addItem and item.difficultyId then --item only drops on a certain difficulty
      if item.difficultyId ~= difficulty then
        addItem = false
      end
    end
    if addItem and type(self.invSlots[slotId]) == "string" then
      if self.invSlots[slotId] ~= item.equipSlot then
        addItem = false
      end
    elseif addItem and type(self.invSlots[slotId]) == "table" then
      local hasSlot = false
      for i=1,#self.invSlots[slotId] do
        if self.invSlots[slotId][i] == item.equipSlot then
          hasSlot = true
          break
        end
      end
      if not hasSlot then
        addItem = false
      end
    end
    if addItem then
      tinsert(items, id, item)
    end
  end
  return items
end

--- Gets the internal item table for the specified itemid
--@param #number itemid The ID of the item
--@return #table The internal item table
function BestInSlot:GetItem(itemid)
  if type(itemid) == "string" then
    itemid = tonumber(itemid)
  end
  if itemid then
    if itemData[itemid] then
      return itemData[itemid]
    else
      BestInSlot.console:AddError("Failed to obtain itemdata", itemid)
      return nil
    end
  end
end

--- Gets a localized description for the supplied unlocalized identifier
-- @param #number datatype Optional datatype to query can be BestInSlot.TYPE_EXPANSION, BestInSlot_TYPE_RAIDTIER, BestInSlot.TYPE_INSTANCE, BestInSlot.TYPE_BOSS or BestInSlot.TYPE_DIFFICULTY
-- @param #multiple arg1 The filter for the supplied datatype
-- @param #multiple arg2 The second filter for the supplied datatype, needed for TYPE_BOSS and TYPE_DIFFUCLTY
function BestInSlot:GetDescription(datatype, arg1, arg2)
  if not arg1 or not datatype then error("This function requires atleast 2 arguments, a datatype and an argument for that datatype") end
  if datatype == self.TYPE_RAIDTIER then
    if not data.raidTiers[arg1] then return "" end
    return data.raidTiers[arg1].description
  elseif datatype == self.TYPE_EXPANSION then
    if not data.expansions[arg1] then return "" end
    return data.expansions[arg1].description
  elseif datatype == self.TYPE_INSTANCE then
    if not data.instances[arg1] then return "" end
    return data.instances[arg1].description
  elseif datatype == self.TYPE_BOSS then
    if not arg2 then error("The GetDescription function for datatype TYPE_BOSS requires 2 arguments") end
    if not data.instances[arg1] then return "" end
    return moduleData[data.instances[arg1].expansion][arg1][arg2].info.name
  elseif datatype == self.TYPE_DIFFICULTY then
    if not arg2 then error("The GetDescription function for datatype TYPE_EXPANSION requires 2 argumets") end
    if not data.raidTiers[arg1] then return "" end
    return data.raidTiers[arg1].difficulties[arg2]
  end
  error(tostring(datatype).." is an invalid datatype!")
end
--- Gets the expansions
-- @param #number datatype Optional datatype to query, if nil it will give all expansions as result can be BestInSlot.TYPE_EXPANSION, BestInSlot_TYPE_RAIDTIER, BestInSlot.TYPE_INSTANCE, BestInSlot.TYPE_BOSS or BestInSlot.TYPE_DIFFICULTY
-- @param #multiple arg The filter for the supplied datatype
function BestInSlot:GetExpansions(datatype, arg)
  if not datatype then
    local expansions = {}
    for k,v in pairs(data.expansions) do
      tinsert(expansions, k)
    end
    return expansions
  elseif datatype == self.TYPE_RAIDTIER then
    if data.raidTiers[arg] then
      return data.raidTiers[arg].expansion
    end
    return ""
  elseif datatype == self.TYPE_INSTANCE then
    if data.instances[arg] then
      return data.instances[arg].expansion
    end
    return ""
  else
    error("Invalid type given!")
  end
end

--- Gets the raidtiers
-- @param #number datatype Optional datatype to query, if nil it will give everything as result can be BestInSlot.TYPE_EXPANSION, BestInSlot_TYPE_RAIDTIER, BestInSlot.TYPE_INSTANCE

-- @param #multiple arg The filter for the supplied datatype
function BestInSlot:GetRaidTiers(datatype, arg)
  local raidTiers = {} 
  -- No Filter
  if not datatype then
    for k,v in pairs(data.raidTiers) do
      tinsert(raidTiers, k)
    end
    return raidTiers
  elseif not arg then return
  -- Expansion filter
  elseif datatype == self.TYPE_EXPANSION then
    if not data.expansions[arg] then return raidTiers end
    for i=1,#data.expansions[arg].raidTiers do
      tinsert(raidTiers, data.expansions[arg].raidTiers[i])
    end
    return raidTiers
  -- Instance filter, will return a single raidTier, not as table!
  elseif datatype == self.TYPE_INSTANCE then
    if data.instances[arg] then
      return data.instances[arg].raidTier
    else return end
  end
end

--- Gets the difficulties
-- @param #number datatype Optional datatype to query, if nil it will give everything as result can be BestInSlot.TYPE_EXPANSION, BestInSlot_TYPE_RAIDTIER, BestInSlot.TYPE_INSTANCE
-- @param #multiple The filter for the supplied datatype
function BestInSlot:GetDifficulties(datatype, arg)
  local difficulties = {}
  if datatype == self.TYPE_RAIDTIER then
    if not data.raidTiers[arg] then return difficulties end
    for i=1,#data.raidTiers[arg].difficulties do
      tinsert(difficulties, data.raidTiers[arg].difficulties[i])
    end
    return difficulties
  elseif datatype == self.TYPE_INSTANCE then
    if not arg or not data.instances[arg] then return difficulties end
    local raidTier = data.instances[arg].raidTier
    for i=1,#data.raidTiers[raidTier].difficulties do
      tinsert(difficulties, data.raidTiers[raidTier].difficulties[i])
    end
    return difficulties
  end
  error("Invalid datatype given!")
end

--- Gets the instances
-- @param #number datatype Optional datatype to query, if nil it will give everything as result can be BestInSlot.TYPE_EXPANSION, BestInSlot_TYPE_RAIDTIER, BestInSlot.TYPE_INSTANCE
-- @param #multiple The filter for the supplied datatype
function BestInSlot:GetInstances(datatype, arg)
  local instances = {}
  if not datatype then
    for k,v in pairs(data.instances) do
      tinsert(instances, k)
    end
    return instances
  elseif datatype == BestInSlot.TYPE_RAIDTIER then
    if not data.raidTiers[arg] then return instances end
    for i=1, #data.raidTiers[arg].instances do
      tinsert(instances, data.raidTiers[arg].instances[i])
    end
    return instances
  end
  error("Invalid datatype given!")
end

function BestInSlot:GetLatest(datatype, filterdatatype, arg)
  -- Get Latest Expansion
  if datatype == self.TYPE_EXPANSION then
    local selectedExpansion
    local selectedRaidTier = 0
    for k,v in pairs(data.expansions) do
      for i=1,#v.raidTiers do
        if v.raidTiers[i] > selectedRaidTier then
          selectedRaidTier = v.raidTiers[i]
          selectedExpansion = k
        end
      end
    end
    return selectedExpansion
    
 -- Get Latest Raid Tier
  elseif datatype == self.TYPE_RAIDTIER then
    local selected = 0
    for k,v in pairs(data.raidTiers) do
      local isFiltered = false
      if filterdatatype then
        if filterdatatype == self.TYPE_EXPANSION and v.expansion ~= arg then
          isFiltered = true
        end
      end
      if not isFiltered then
        selected = math.max(selected, k)
      end
    end
    return selected
  -- Get Latest Instance (based on latest raid tier, if no args given)
  elseif datatype == self.TYPE_INSTANCE then
    local latestRaidTier = self:GetLatest(self.TYPE_RAIDTIER)
    return data.raidTiers[latestRaidTier].instances[#data.raidTiers[latestRaidTier].instances]
  end
  error(tostring(datatype).." is an invalid datatype")
end

---Gets the bosses for the instance
--@param #string instance The instance to get the bosses for
--@return #table Table with boss names, the id of the boss is the same as the table index
function BestInSlot:GetInstanceBosses(instance)
  local bosses = {}
  local instanceData = moduleData[data.instances[instance].expansion][instance]
  for i=1,#instanceData do
    tinsert(bosses, instanceData[i].info.name)
  end
  return bosses
end

local function helperGetBestInSlotItems(raidTier, difficulty, specialization)
  local slots = BestInSlot.slots
  local requiredItems = {}
  if not data.raidTiers[raidTier] then return requiredItems end
  for i=1,#slots do
    local slotid = GetInventorySlotInfo(slots[i])
    local itemid = BestInSlot.db.char[raidTier][difficulty][specialization][slotid]
    if type(itemid) == "number" then
      local itemRecord = {item = itemid, obtained = false}
      itemRecord.isCustom = BestInSlot:IsItemCustom(itemid)
      tinsert(requiredItems, itemRecord)
    end
  end
  return requiredItems
end

--- Get the current BestInSlot items for the raidTier and difficulty
-- @param #number raidTier The raidTier to get the BestInSlot from
-- @param #number difficulty The Difficulty to request
function BestInSlot:GetBestInSlotItems(raidTier, difficulty, specialization)
  if not raidTier or not difficulty then BestInSlot.console:AddError("BestInSlot:GetBestInSlot() missed paramter RaidTier or difficulty", raidTier, difficulty, specialization) end
  if not specialization then
    local bisItems = {}
    for i=1,GetNumSpecializations() do
      local specId = GetSpecializationInfo(i)
      bisItems[specId] = helperGetBestInSlotItems(raidTier,difficulty,specId)
    end
    bisItems.spec = GetSpecializationInfo(self:GetSpecialization())
    return bisItems
  else
    return helperGetBestInSlotItems(raidTier,difficulty,specialization)
  end
end

--- Makes a custom item
-- @param #number itemid The itemid of the custom item
-- @param #string type Either "MISC" or "INSTANCE" explaining the source of the item
-- @param #number raidTier The Raid tier to register the custom item with
-- @param #number difficulty Optional difficulty to add it to
-- @param #string [dungeon] The dungeon identifier, only required when type is "INSTANCE"
-- @param #number [boss] The boss ID, only required when type is "INSTANCE"
function BestInSlot:GetCustomItem(itemid, type, raidTier, difficulty, dungeon, boss)
  local itemInfo = {}
  itemInfo.raidId = dungeon
  itemInfo.expansionId = self:GetExpansions(self.TYPE_RAIDTIER, raidTier)
  itemInfo.raidTier = raidTier
  itemInfo.bossid = boss
  if type == "INSTANCE" then
    itemInfo.source = self:GetDescription(self.TYPE_BOSS, dungeon, boss)
  else
    itemInfo.source = L["Custom item"]
  end
  itemInfo.difficultyId = difficulty
  itemInfo.isCustom = true
  SetItemInfoData(itemInfo, itemid)
  return itemInfo
end

--- Checks wether the supplied itemid is BestInSlot
-- @param number itemdId The itemid to check
-- @return number Number representing the spec for which it is BiS
-- @return boolean false if not best in slot
function BestInSlot:IsItemBestInSlot(itemId)
  if itemData[itemId] then
    if tostring(itemData[itemId].isBiS) ~= "nil" then
      return itemData[itemId].isBiS
    end
  end
  local raidTiers = self:GetRaidTiers()
  local specs = self:GetAllSpecializations()
  for i=1,#raidTiers do
    local raidTier = raidTiers[i]
    local bisList = self.db.char[raidTier]
    if #bisList ~= 0 then
      local difficulties = self:GetDifficulties(self.TYPE_RAIDTIER, raidTier)
      for i=1, #difficulties do
        for specId in pairs(specs) do
          for j in pairs(bisList[i][specId]) do
            if bisList[i][specId][j] == itemId then
              return specId
            end
          end
        end
      end
    end
  end
  return false
end

--- Set the item as BestInSlot item
-- @param #number raidTier The raid tier to add the item to
-- @param #number difficultyId The difficulty to add the item to
-- @param #number specialization The specialization ID
-- @param #number slotId The slot to add the item to
-- @param #number itemId The item ID to add
function BestInSlot:SetItemBestInSlot(raidTier, difficultyId, specialization, slotId, itemId)
  local currentId = self.db.char[raidTier][difficultyId][specialization][slotId]
  if type(currentId) == "number" then --Checks if the number was fetched, default return from DB is an empty array
    if itemData[currentId] then --checks if the item is present in the cahce, if so we need to set it's BiS to false
      itemData[currentId].isBiS = false
    end
  end
  self.db.char[raidTier][difficultyId][specialization][slotId] = itemId
  if IsInGuild() and self.options.sendAutomaticUpdates then
    local msg = {raidTier = raidTier, difficulty = difficultyId, bis = self:GetBestInSlotItems(raidTier, difficultyId, specialization), spec = specialization}
    self:SendAddonMessage("automaticUpdate",msg, "GUILD") 
  end
  if itemId and itemData[itemId] then
    itemData[itemId].isBiS = specialization
  end
end

--- Used for adding custom items
--@param #number itemid The item id to add
--@param #string type Either "MISC" or "INSTANCE" to indicate which to add
--@param #number raidTier The number corresponding with the raidTier that you want to add the item to
--@param #number difficulty The Difficutly ID of the raidTier to add the item to
--@param #string dungeon The dungeon ID to add the item to, only needed at the "INSTANCE" type
--@param #number boss The boss ID in the dungeon where this item drops, only needed at the "INSTANCE" type 
function BestInSlot:AddCustomItem(itemid, type, raidTier, difficulty, dungeon, boss)
  if not itemid or not type or not raidTier or not difficulty then error("Invalid parameters supplied") end
  if type ~= "MISC" and type ~= "INSTANCE" then error("Invalid type, must be either \"MISC\" or \"INSTANCE\"") end
  if type == "INSTANCE" and (not dungeon or not boss) then error("Not enough parameters given, the instance parameter requires a dungeon and boss") end
  if not data.raidTiers[raidTier] then error("Invalid raidTier given!") end
  local customItems = self.db.global.customItems
  tinsert(customItems,itemid, {
    type = type,
    raidTier = raidTier,
    difficulty = difficulty,
    dungeon = dungeon,
    boss = boss,
  })
  local item = self:GetCustomItem(itemid, type, raidTier, difficulty, dungeon, boss)
  itemData[itemid] = item
end

--- Checks if the supplied item is a custom item
-- @param #number itemid The itemid to check
-- @return True if the item is custom, otherwise false
function BestInSlot:IsItemCustom(itemid)
  local savedItems = self.db.global.customItems
  for itemId, data in pairs(savedItems) do
    if itemid == itemId and data.raidTier then
      return true
    end
  end
  return false
end

local function tableHasItems(table)
  if type(table) == "table" then
    for _ in pairs(table) do
      return true
    end
  end
  return false
end

--- Gets the cached BiS lists
-- @return The Bis lists
function BestInSlot:GetCacheData()
  local db = self.db.factionrealm
  local result = {}
  local raidTiers = {}
  local guilds = {}
  for guildName, guildData in pairs(db) do
    if tableHasItems(guildData) then
      tinsert(guilds, guildName)
      for playerName, playerData in pairs(guildData) do
        if tableHasItems(playerData) then
          --checks if the player allready exists in the table
          result[playerName] = {guild = guildName}
          
          for raidTier, raidTierData in pairs(playerData) do
            if tableHasItems(raidTierData) then
              --checks if the raidTier allready exists in the table
              local addRaidTier = true
              for i=1,#raidTiers do
                if raidTiers[i] == raidTier then
                  addRaidTier = false
                  break
                end
              end
              if addRaidTier then
                tinsert(raidTiers, raidTier)
              end
              
              for difficulty, bisList in pairs(raidTierData) do
                if tableHasItems(bisList) then
                  tinsert(result[playerName], {raidTier, difficulty})
                end
              end
            end
          end
        end
      end
    end
  end
  return result, raidTiers, guilds
end

--- Function to catch the nil that GetSpecialization() returns
-- @return 1,2,3,4 depending on the character's specialization, defaults to 1 if none selected
function BestInSlot:GetSpecialization()
  return GetSpecialization() or 1
end

--- Function to get all the specializations of the player
-- @return table Table with as index the global ID and value the localized description
function BestInSlot:GetAllSpecializations()
  local result = {}
  for i=1,GetNumSpecializations() do
    local id, name = GetSpecializationInfo(i)
    result[id] = name
  end
  return result
end

local mt = {
  __index = function(table, key)
    if rawget(table, key) then return rawget(table, key) end
    if IsInRaid() then
      for i=1,40 do
        local name, realm = UnitName("raid"..i)
        if name and not realm and name == key then
          local class, localized = UnitClass("raid"..i)
          table[key] = {class, localized}
          BestInSlot:Print(table[key])
          return {class, localized}
        end
      end
    elseif IsInGroup() then
      for i=1,5 do
        local name, realm = UnitName("party"..i)
        if name and not realm and name == key then
          local localized, class = UnitClass("party"..i)
          table[key] = {class, localized}
          BestInSlot:Print(table[key])
          return {class, localized}
        end
      end
    end
    if IsInGuild() then
      for i=1,GetNumGuildMembers() do
        local nameWithRealm, _, _, _, localizedClass, _, _, _, _, _, class = GetGuildRosterInfo(i)
        local playerName = (nameWithRealm):match("(%D+)-(%D+)")
        if playerName == key then
          table[key] = {class, localizedClass}
          return {class, localizedClass}
        end
      end
    end
    return rawget(table, "DEFAULT")
  end
} 
local playerClassCache = {
  DEFAULT = {}
}
setmetatable(playerClassCache, mt)

--- Lookup what class a player in the guild is
-- @param #string name The name of the player to lookup
-- @return #string The class of the player if found
-- @return #nil Nil if the player was not found
function BestInSlot:GetPlayerClass(name)
  if not name then return end
  return playerClassCache[name][1], playerClassCache[name][2]
end


local hex = {}
for i=0,9 do
  hex[i] = tostring(i)
end
hex[10] = 'a'
hex[11] = 'b'
hex[12] = 'c'
hex[13] = 'd'
hex[14] = 'e'
hex[15] = 'f'

--- Converts a number to a string representation of a hex
-- @param #number number The number to convert
-- @return #string A string representation of a hex
function BestInSlot:ToHexString(number)
  number = math.floor(number)
  if number > 2147483647 or number < 0 then
    error("Out of bounds, this function only works for numbers higher then 0 and below 2147483647")
  end
  if number >= 16 then
    return self:ToHexString(bit.rshift(number, 4))..self:ToHexString(bit.band(number, 15))
  end
  return hex[number]
end

function BestInSlot:GetPlayerString(name)
  local playerClass = self:GetPlayerClass(name)
  if not playerClass then
    return ("|cffb5b4ff%s|r"):format(name or "Unknown name")
  else
    return ("%s%s|r"):format(self:GetClassColor(playerClass) or "|cffb5b4ff", name or "Unknown name")
  end
end

function BestInSlot:GetClassColor(class)
  if RAID_CLASS_COLORS[class] then
    return "|c"..RAID_CLASS_COLORS[class].colorStr
  end
end

function BestInSlot:GetClassString(class)
  return (self:GetClassColor(class) or "|cffb5ffb4")..(LOCALIZED_CLASS_NAMES_MALE[class] or "Unknown class").."|r"
end

